if(ForceRequiredAddon("Weapon_SWeps") == $Error::AddOn_NotFound)
	return;
AddDamageType("TommyGun",'<bitmap:Add-Ons/Weapon_SWeps_TommyGun/ci_TommyGun> %1','%2 <bitmap:Add-Ons/Weapon_SWeps_TommyGun/ci_TommyGun> %1',0.2,1);
swolammo_addAmmoType("45ACP","45 ACP",50*3,50);
	
datablock ItemData(ammo45ACPItem : ammoBox9mmItemA)
{
	shapeFile = "./ammo_tommyGun.dts";
	iconName = "./icon_ammo45ACP";
	uiName = "Ammo 45 ACP Drum";
	sAmmo = 50;
	sAmmoType = "45ACP";
	colorShiftColor = "1 1 1 1";
	doColorShift = false;
	alwaysMaxAmmo = 1;
};
datablock explosionData(tommyGunExplosion : gunExplosion)
{
	soundProfile = "";
	particleEmitter = "";
	subExplosion[0] = sWepsDustSmallExplosion;
};
datablock ProjectileData(tommyGunProjectile : gunProjectile)
{
	projectileShapeName 	= "base/data/shapes/empty.dts";
	directDamage        	= 17;
	explosion 				= tommyGunExplosion;
	directDamageType    	= $DamageType::TommyGun;
	radiusDamageType    	= $DamageType::TommyGun;
	particleEmitter     	= sWepBulletTrailEmitter;
	uiName 					= "";
	muzzleVelocity 			= 200;
	verticalImpulse 		= 20;
	impactImpulse			= 20;
	sProjectile = 1;
	sDamageFalloff = 1;
	sDamageFalloffRatio = 1;
};
datablock AudioProfile(tommyGunFireLoopEndSound)
{
	filename    = "./tommyGun_fireLoopEnd.wav";
	description = AudioClose3d;
	preload = true;
};
datablock AudioProfile(tommyGunFireLoopSound : tommyGunFireLoopEndSound)
{
	filename    = "./tommyGun_fireLoop.wav";
	description = AudioDefaultLooping3D;
};
datablock AudioProfile(tommyGunLoadSound : ar15FireLoopEndSound)
{
	filename    = "./tommyGun_load.wav";
	description = AudioClosest3d;
};
datablock AudioProfile(tommyGunUnloadSound : ar15FireLoopEndSound)
{
	filename    = "./tommyGun_unload.wav";
	description = AudioClosest3d;
};
datablock DebrisData(tommyGunClipDebris)
{
	shapeFile = "./mag_tommyGun.dts";
	lifetime = 6.0;
	lifetimeVariance = 1.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 4;
};
datablock ExplosionData(tommyGunClipExplosion)
{
	debris 					= tommyGunClipDebris;
	debrisNum 				= 1;
	debrisNumVariance 		= 0;
	debrisPhiMin 			= 0;
	debrisPhiMax 			= 360;
	debrisThetaMin 			= 0;
	debrisThetaMax 			= 180;
	debrisVelocity 			= 1;
	debrisVelocityVariance 	= 0;
};
datablock ProjectileData(tommyGunClipProjectile)
{
	explosion = tommyGunClipExplosion;
};
if($Pref::Swol_CreateFakeIcons)
{
	datablock ItemData(tommyGunIcon)
	{
		uiName = "Tommy Gun";
		iconName = "./icon_tommyGun";
	};
}
datablock ItemData(tommyGunItem)
{
	category = "Weapon";
	className = "Weapon";
	
	weaponClass = "primary";

	shapeFile = "./tommyGun.dts";
	rotate = false;
	mass = 1;
	density = 0.2;
	elasticity = 0.2;
	friction = 0.6;
	emap = true;

	uiName = "Tommy Gun";
	iconName = "./icon_tommyGun";
	fakeIcon = tommyGunIcon;
	doColorShift = true;
	colorShiftColor = "0.57 0.35 0.2 1";
	ammo = 1;
	canPutInSuitcase = 0;
	isLargeWeapon = 1;

	image = tommyGunImage;
	canDrop = true;
	
	sAmmoType = "45ACP";
	sAmmo = 50;
	sHeat = 25;
};
datablock ShapeBaseImageData(tommyGunImage)
{
	className = "WeaponImage";
	shapeFile = "./tommyGun.dts";
	emap = true;
	mountPoint = 0;
	offset = "0 0.05 0.03";
	item = tommyGunItem;
	ammo = " ";
	projectile = tommyGunProjectile;
	projectileType = Projectile;
	
	casing = shell9mmDebris;
	shellExitDir        = "1.14 -0.7 0.2";
	shellExitDir        = "1.2 -1.3 0.5";
	shellExitOffset     = "0 0 0";
	shellExitVariance   = 12.0;	
	shellVelocity       = 7.0;
	
	armReady = true;
	
	eyeOffset = 0;
	
	doColorShift = true;
	colorShiftColor = tommyGunItem.colorShiftColor;
	
	stateName[0]					= "Ready";
	stateSequence[0]				= "root";
	stateTimeoutValue[0]			= 0.3;
	stateTransitionOnTimeout[0] 	= "Idle";
	
	stateName[1]					= "Idle";
	stateTransitionOnNotLoaded[1]	= "UnloadA";
	stateTransitionOnTriggerDown[1]	= "Trigger";
	
	stateName[2]					= "Trigger";
	stateScript[2]					= "onTrigger";
	stateTimeoutValue[2]			= 0.02;
	stateSound[2]					= mac10TrigSound;
	stateSequence[2]				= "trig";
	stateTransitionOnTimeout[2]		= "FireCheckA";
	
	stateName[3]					= "FireCheckA";
	stateScript[3]					= "onFireCheck";
	stateTimeoutValue[3]			= 0.01;
	stateTransitionOnTimeout[3]		= "FireCheckB";
	
	stateName[4]					= "FireCheckB";
	stateTransitionOnAmmo[4]		= "Fire";
	stateTransitionOnNoAmmo[4]		= "DryFire";
	
	stateName[5]					= "Fire";
	stateScript[5]					= "onFire";
	stateEmitter[5]					= gunFlashEmitter;
	stateEmitterTime[5]				= 0.09;
	stateFire[5]					= true;
	stateEjectShell[5]				= true;
	stateSequence[5]				= "fire";
	stateEmitterNode[5]				= "muzzlePoint";
	stateTransitionOnTimeout[5]     = "Check";
	stateTimeoutValue[5]            = 0.065;
	
	stateName[6]					= "Check";
	stateTransitionOnTriggerDown[6] = "FireCheckA";
	stateTransitionOnTimeout[6]		= "Release";
	
	stateName[7]					= "Release";
	stateScript[7]					= "onRelease";
	stateSequence[7]				= "untrig";
	stateTimeoutValue[7]			= 0.05;
	stateTransitionOnTimeout[7]		= "Wait";
	
	stateName[8]					= "Wait";
	stateTimeoutValue[8]			= 0.05;
	stateTransitionOnTimeout[8]		= "Idle";
	
	stateName[9]					= "UnloadA";
	stateSequence[9]				= "unload";
	stateTimeoutValue[9]			= 0.01;
	stateScript[9]					= "onUnload";
	stateTransitionOnTimeout[9]		= "UnloadB";
	
	stateName[10]					= "UnloadB";
	stateTimeoutValue[10]			= 1.9;
	stateTransitionOnTimeout[10]	= "ReloadA";
	
	stateName[11]					= "ReloadA";
	stateSequence[11]				= "reload";
	stateTimeoutValue[11]			= 0.01;
	stateScript[11]					= "onReloadA";
	stateTransitionOnTimeout[11]	= "ReloadB";
	
	stateName[12]					= "ReloadB";
	stateTimeoutValue[12]			= 1.1;
	stateTransitionOnTimeout[12]	= "ReloadC";
	
	stateName[13]					= "ReloadC";
	stateScript[13]					= "onReloadB";
	stateTimeoutValue[13]			= 0.1;
	stateTransitionOnTimeout[13]	= "Idle";
	
	stateName[14]					= "DryFire";
	stateScript[14]					= "onDryFire";
	stateTransitionOnTriggerUp[14]	= "Release";
};
function tommyGunImage::onFireCheck(%db,%pl,%slot)
{
	%pl.setImageAmmo(%slot,sAmmo_check(%db,%pl,%slot));
}
function tommyGunImage::onFire(%db,%pl,%slot)
{
	if(%pl.getDamagePercent() >= 1)
		return;
	if(!%pl.isPlayingLoopingAudio[%db,%slot+1])
	{
		%pl.playAudio(%slot+1,tommyGunFireLoopSound);
		%pl.isPlayingLoopingAudio[%db,%slot+1] = 1;
	}
	%pl.playThread(2,plant);
	
	%pl.sAmmo_heat[%db] = mClamp(%pl.sAmmo_heat[%db]+1,0,%db.item.sHeat);
	sAmmo_fire(%db,%pl,%slot,0.01+((%pl.sAmmo_heat[%db]/%db.item.sHeat)*0.035),180,1);
	cancel(%pl.sAmmoCooldownHeatSched[%db]);
	%pl.sAmmoCooldownHeatSched[%db] = %pl.schedule(200,sAmmo_heatCooldown,%db,%slot);
	
	%val = sAmmo_dec(%db,%pl,%slot);
	if(!sAmmo_check(%db,%pl,%slot))
		serverPlay3D(mac10LastRoundSound,%pl.getPosition());
		
	if(getSimTime()-%pl.lastShellSound > 400 || getRandom(0,1) == 0)
	{
		%pl.lastShellSound = getSimTime();
		schedule(getRandom(200,300),0,serverPlay3D,small_bulletDrop @ getRandom(1,5) @ Sound,%pl.getPosition());
	}
	if(%val == 0)
		%pl.setImageAmmo(%slot,0);
}
function tommyGunImage::onUnload(%db,%pl,%slot)
{
	sAmmo_display(%pl,0);
	%up = %pl.getUpVectorHack();
	%forward = %pl.getEyeVectorHack();
	
	%p = new projectile()
	{
		datablock = tommyGunClipProjectile;
		initialPosition = vectorAdd(%pl.getMuzzlePoint(%slot),vectorRelativeShift(%forward,%up,"-1.6 0 -1.2"));
	};
	%p.explode();
	%pl.playThread(2,shiftTo);
	serverPlay3D(tommyGunUnloadSound,%pl.getPosition());
}
function tommyGunImage::onReloadA(%db,%pl,%slot)
{
	%pl.playThread(2,plant);
	serverPlay3D(tommyGunLoadSound,%pl.getPosition());
	sAmmo_reload(%db,%pl,%slot);
	%pl.sAmmo_fireDelay = getSimTIme()+800;
}
function tommyGunImage::onReloadB(%db,%pl,%slot)
{
	//%pl.playThread(2,shiftLeft);
	%pl.setImageLoaded(%slot,1);
}
function tommyGunImage::onRelease(%db,%pl,%slot)
{
	if(%pl.isPlayingLoopingAudio[%db,%slot+1])
	{
		%pl.isPlayingLoopingAudio[%db,%slot+1] = 0;
		%pl.stopAudio(%slot+1);
		serverPlay3D(tommyGunFireLoopEndSound,%pl.getPosition());
	}
}
function tommyGunImage::onDryFire(%db,%pl,%slot)
{
	if(%pl.isPlayingLoopingAudio[%db,%slot+1])
	{
		%pl.isPlayingLoopingAudio[%db,%slot+1] = 0;
		%pl.stopAudio(%slot+1);
		serverPlay3D(tommyGunFireLoopEndSound,%pl.getPosition());
	}
	%pl.sAmmo_warn = "warn";
	%pl.sAmmo_warnMax = 150;
	%pl.sAmmo_lastWarn = getSimTime();
	sAmmo_display(%pl);
	serverPlay3D(ar15DryFireSound,%pl.getPosition());
}
function tommyGunImage::onUnMount(%db,%pl,%slot)
{
	if(%pl.isPlayingLoopingAudio[%db,%slot+1])
	{
		%pl.isPlayingLoopingAudio[%db,%slot+1] = 0;
		%pl.stopAudio(%slot+1);
		serverPlay3D(tommyGunFireLoopEndSound,%pl.getPosition());
	}
	parent::onUnMount(%db,%pl,%slot);
}